package com.mt.wms.empty.service;

import com.mt.wms.core.params.IdParam;
import com.mt.wms.core.vo.IdVo;
import com.mt.wms.core.vo.PageVo;
import com.mt.wms.core.vo.R;
import com.mt.wms.empty.params.CurrTaskQueryParam;
import com.mt.wms.empty.params.TaskCreateParam;
import com.mt.wms.empty.vo.CurrTaskQueryVo;
import com.mt.wms.empty.vo.CurrTaskVo;

/**
 * 拆分任务相关服务
 *
 * @author xcc
 * @date 2021年11月8日
 * @since 1.0
 */
public interface CurrTaskService {

    /**
     * 内部使用，获取详情任务的关联任务
     * @param idParam 任务id
     * @return 任务实体
     */
    CurrTaskVo getCurrTask(IdParam idParam);


    /**
     * 创建加工任务的主任务信息
     *
     * @param param 主任务信息
     * @return 结果
     */
    R<IdVo> createProcessTask(TaskCreateParam param);

    /**
     * 查询分页信息
     *
     * @param param 查询参数
     * @return 结果
     */
    R<PageVo<CurrTaskQueryVo>> currentTaskPage(CurrTaskQueryParam param);

    /**
     * 完成执行任务
     *
     * @param param id
     * @return 结果
     */
    R<String> completeTask(IdParam param);
}
